<?php
function mt_fields() {
	return array('title', 'text', 'text_more', 'excerpt', 'keywords');
}
function blog_data($db, $type, $blog_id) {
	return load_plugindata($db, 'rightfields', config_key($blog_id, $type));
}
function config_key($blog_id, $type) {
	if ($blog_id == -1) {
		return "default_$type";
	} else {
		return "blog_{$blog_id}_cfg_$type";
	}
}
function load_plugindata($db, $plugin, $key) {
	$sql = <<<SQL
SELECT plugindata_data
FROM mt_plugindata
WHERE plugindata_plugin = '$plugin'
AND plugindata_key = '$key'
SQL;
	list($data) = $db->get_results($sql, ARRAY_A);
	return $db->unserialize($data['plugindata_data']);
}
function new_obj($db, $cfg, $entry_id) {
	if ($cfg['datasource'] == '_pseudo') {
		$data = load_plugindata($db, 'RightFieldsPseudo', $entry_id);
		unset($data['entry_id']);
	} else {
		$sql = <<<SQL
SELECT * FROM mt_{$cfg['datasource']}
WHERE {$cfg['datasource']}_id = $entry_id
SQL;
		list($data) = $db->get_results($sql, ARRAY_A);
	}
	if ($data) {
		return $data;
	} else {
		return array();
	}
}
function sort_cols($a, $b) {
	GLOBAL $rf_cfg;
	return ($rf_cfg['cols'][$a]['sort'] > $rf_cfg['cols'][$b]['sort']) ? 1 : -1;
}
function get_col($args, $ctx) {
	return $ctx->stash('rf_col') ? $ctx->stash('rf_col') : $args['field'];
}
function sort_entries_title_asc($a, $b) {
	return ($a['entry_title'] > $b['entry_title']) ? 1 : -1;
}
function sort_entries_title_desc($a, $b) {
	return ($a['entry_title'] < $b['entry_title']) ? 1 : -1;
}
function sort_entries_date_asc($a, $b) {
	return ($a['entry_created_on'] > $b['entry_created_on']) ? 1 : -1;
}
function sort_entries_date_desc($a, $b) {
	return ($a['entry_created_on'] < $b['entry_created_on']) ? 1 : -1;
}
function get_elem($args, $ctx, $elem) {
	$entry = $ctx->stash('entry');
	if (!$entry) return '';
	$field = get_col($args, $ctx);
	$mt_fields = mt_fields();
	if (array_search($field, $mt_fields)) {
		$cfg = blog_data($ctx->mt->db, 'standard', $entry['entry_blog_id']);
		$col = $cfg[$field];
	} else {
		$cfg = blog_data($ctx->mt->db, 'extra', $entry['entry_blog_id']);
		$col = $cfg['cols'][$field];
	}
	return $col[$elem];

}
function extra_field_value($args, $ctx) {
	$entry = $ctx->stash('entry');
	$fields = $ctx->stash('rf_extra');
	$cfg = $ctx->stash('rf_extra_cfg');
	if (!$fields) return '';
	$col = get_col($args, $ctx);
	if ($cfg['datasource'] != '_pseudo') {
		$db_col = $cfg['datasource'] . '_' . $col;
	}
	$val = $fields[$db_col];
	if (($cfg['cols'][$col]['type'] == 'menu')
			|| ($cfg['cols'][$col]['type'] == 'radio')) {
		if ($args['show_key']) return $val;
		$find = quotemeta($val);
		foreach (explode("\n", $cfg['cols'][$col]['choices']) as $choice) {
			if (!$choice) continue;
			if (preg_match("/^$find=/", $choice)) {
				list($key, $val) = explode('=', $choice);
			}
		}
	}
	return $val;
}
function field_value($args, $ctx) {
	$field = get_col($args, $ctx);
	$entry = $ctx->stash('entry');
	$val = $entry["entry_$field"];
	$cfg = blog_data($ctx->mt->db, 'standard', $entry['entry_blog_id']);
	if (!$cfg[$field]['customize']) return $val;
	if (($cfg[$field]['type'] == 'menu')
			|| ($cfg[$field]['type'] == 'radio')) {
		if ($args['show_key']) return $val;
		$find = quotemeta($val);
		foreach (explode("\n", $cfg[$field]['choices']) as $choice) {
			if (!$choice) continue;
			if (preg_match("/^$find=/", $choice)) {
				list($key, $val) = explode('=', $choice);
				break;
			}
		}
	}
	return $val;
}
?>